/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "CMYAlg.h"
#include "RGB.h"
#include <stdio.h>

void CMYAlg::touchDataLines(Map *imageMap, int start,int len,void *ptr)
{
	for(int y = 0; y < len; y++)
	{
		for(int x = 0; x < imageMap->width; x++)
		{
			//convert RGB to CMY somehow better than this
			RGB *rgb = &((RGB *)ptr)[y*imageMap->width + x];
			
			unsigned char yc = (255-rgb->b)/128;
			unsigned char mc = (255-rgb->g)/128;
			unsigned char cc = (255-rgb->r)/128;

			rgb->r = yc;
			rgb->b = mc;
			rgb->g = cc;
		}
	}
}

