/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _MAP
#define _MAP

#include "MapAlgorithm.h"
#include "LinkedList.h"

#define getMapCell(m,x,y) &m->bytes[((y - m->start) * m->width + x) * m->cellSize]

class Map
{
 private:
	int end; /* ending line data is saved, exclusive */
	LinkedList *rootAlg;
	
 public:
	//only public so inline macro can be used
	int start; /* starting line data is saved from */
	char *bytes;
	int cellSize; 

	int width;  /* width of map in cells */
	int height; /* height of map in cells */

	Map(int width, int height, int cellSize);
	~Map();

	void cacheLines(int start, int len);
	void addAlgorithm(MapAlgorithm *algorithm);

	void *getCell(int x, int y);
};

#endif
