/*
Lexmark 1100 printer driver for Linux
Copyright (C) 1999   Tim Engler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// A Sponge Writer has an internal buffer which will write to an output stream when it is ready.
// It uses threads! Phbbbbbbt!
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <pthread.h>
#include "Writer.h"
#include "ThreadSafeCircleBuffer.h"

void *writeBuffer(void *arg);

class SpongeWriter : public Writer
{
 private:
	int fd;
	int maxSize;
	pthread_t thread;

	bool valid; // used for thread synchronization, if false, class is about to be destroyed
	bool firstWrite; // used for thread synchronization, if false, class is about to be destroyed

	ThreadSafeCircleBuffer *buffer;

	friend void *writeBuffer(void *arg);
	
 public:
	SpongeWriter(int maxSize, int fd);
	~SpongeWriter();
	
	void write(char *data, int length);
};


